#include <bits/stdc++.h>
#include <vector>
using namespace std;

long long rez[300005];
int main() {
    long long n,q;
    cin>>n>>q;
    vector<pair<long long,long long>> danKeks;
    long long x,y;
    
    for(int i=0;i<n;i++){
        cin>>x>>y;
        danKeks.push_back({x,y});
    }
    
    long long k;
    long long i=0;long long g=0;
    while(q--){
        i=0;
        cin>>k;
        long long danTr=danKeks[i].first;
        long long keks=danKeks[i].second;
        long long zbir=0;
        
        while(i<n&&danTr<=k){
            
            keks--;
            zbir++;
            danTr++;
            if(keks==0){
                i++;
                danTr=danKeks[i].first;
                keks=danKeks[i].second;
                //zbir++;
            }
            
           //cout<<danTr<<"\n"<<endl;
            
        }
        
        rez[g]=zbir;
        //cout<<rez[g]<<"\n"<<endl;
        g++;
        
    }
    
    for(int i=0;i<g;i++){
        cout<<rez[i]<<"\n";
    }
    
    cout<<endl;
    
    return 0;
}